#include <SDL2/SDL.h>

class lib {

protected:

    SDL_Surface*        screen_surface = NULL;
    SDL_Window*         sdl_window = NULL;
    SDL_Renderer*       sdl_renderer;
    SDL_PixelFormat*    sdl_pixel_format;
    SDL_Texture*        sdl_screen_texture;
    SDL_Event           event;

    Uint32* screen_buffer;
    Uint32  width, height;
    Uint32  frame_length;
    Uint32  frame_prev_ticks;

    int     _scale, _width, _height, _frameid;
    int     kb_code, kb_trigger;

public:

     lib(int w, int h, int scale, int fps);
    ~lib();

    // -----------------------------------------------------------------
    // Обработка окна
    // -----------------------------------------------------------------

    int     createwin(int w, int h, int scale, const char* name, int fps);
    int     handler ();
    void    update  ();
    void    destroy ();
    int     get_kbcode();

    // -----------------------------------------------------------------
    // Рисование в буфере
    // -----------------------------------------------------------------

    void    scale   (int v);
    int     frameid ();
    void    pset    (int x, int y, Uint32 cl);
    void    line    (int x1, int y1, int x2, int y2, Uint32 color);
    void    circle  (int xc, int yc, int radius, int color);
    void    circlef (int xc, int yc, int radius, int color);
};
